## fatsort 0.9.4

=== Makefile ===
all: fatsort
	gcc fatsort.c -o fatsort
clean:
	rm -f fatsort

## fatsort 0.9.6.1

=== Makefile ===
all:
	gcc ${CFLAGS} fatsort.c -o fatsort
clean:
	rm -f fatsort

## fatsort 0.9.7.1

=== Makefile ===
all:
	gcc ${CFLAGS} -D_LARGEFILE_SOURCE -D_FILE_OFFSET_BITS=64 fatsort.c -o fatsort
clean:
	rm -f fatsort

## fatsort 0.9.8.2

=== Makefile ===
all:
	$(MAKE) -C src/
clean:
	$(MAKE) -C src/ clean
install:
	$(MAKE) -C src/ install

=== src/Makefile ===
CC=gcc
LD=gcc
CFLAGS += -g -Wall -D_LARGEFILE_SOURCE -D_FILE_OFFSET_BITS=64
LDFLAGS = -s 
SBINDIR=/usr/local/sbin

all: fatsort

fatsort: fatsort.o FAT_fs.o fileio.o endianness.o signal.o entrylist.o errors.o options.o clusterchain.o sort.o misc.o Makefile
	${LD} ${LDFLAGS} *.o -o fatsort

fatsort.o: fatsort.c endianness.h signal.h FAT_fs.h options.h errors.h sort.h misc.h Makefile
	$(CC) ${CFLAGS} -c $< -o $@

FAT_fs.o: FAT_fs.c FAT_fs.h fileio.h endianness.h errors.h Makefile
	$(CC) ${CFLAGS} -c $< -o $@

fileio.o: fileio.c fileio.h Makefile
	$(CC) ${CFLAGS} -c $< -o $@

endianness.o: endianness.c endianness.h Makefile
	$(CC) ${CFLAGS} -c $< -o $@

signal.o: signal.c signal.h Makefile
	$(CC) ${CFLAGS} -c $< -o $@

entrylist.o: entrylist.c entrylist.h options.h errors.h FAT_fs.h Makefile
	$(CC) ${CFLAGS} -c $< -o $@

errors.o: errors.c errors.h Makefile
	$(CC) ${CFLAGS} -c $< -o $@

options.o: options.c options.h errors.h Makefile
	$(CC) ${CFLAGS} -c $< -o $@

clusterchain.o: clusterchain.c clusterchain.h errors.h Makefile
	$(CC) ${CFLAGS} -c $< -o $@

sort.o: sort.c sort.h options.h FAT_fs.h fileio.h entrylist.h errors.h endianness.h clusterchain.h signal.h misc.h platform.h Makefile
	$(CC) ${CFLAGS} -c $< -o $@

misc.o: misc.c misc.h options.h Makefile
	$(CC) ${CFLAGS} -c $< -o $@

install:
	install -m 0755 -p -D fatsort $(DESTDIR)$(SBINDIR)

clean:
	rm -f *.o fatsort

.PHONY: all clean

## fatsort 0.9.12

=== src/Makefile ===
--- 
+++ 
@@ -1,12 +1,13 @@
 CC=gcc
 LD=gcc
-CFLAGS += -g -Wall -D_LARGEFILE_SOURCE -D_FILE_OFFSET_BITS=64
+CFLAGS += -g -Wall
+override CFLAGS+= -D_LARGEFILE_SOURCE -D_FILE_OFFSET_BITS=64
 LDFLAGS = -s 
 SBINDIR=/usr/local/sbin
 
 all: fatsort
 
-fatsort: fatsort.o FAT_fs.o fileio.o endianness.o signal.o entrylist.o errors.o options.o clusterchain.o sort.o misc.o Makefile
+fatsort: fatsort.o FAT_fs.o fileio.o endianness.o signal.o entrylist.o errors.o options.o clusterchain.o sort.o misc.o natstrcmp.o Makefile
 	${LD} ${LDFLAGS} *.o -o fatsort
 
 fatsort.o: fatsort.c endianness.h signal.h FAT_fs.h options.h errors.h sort.h misc.h Makefile
@@ -24,13 +25,13 @@
 signal.o: signal.c signal.h Makefile
 	$(CC) ${CFLAGS} -c $< -o $@
 
-entrylist.o: entrylist.c entrylist.h options.h errors.h FAT_fs.h Makefile
+entrylist.o: entrylist.c entrylist.h options.h errors.h FAT_fs.h natstrcmp.h Makefile
 	$(CC) ${CFLAGS} -c $< -o $@
 
 errors.o: errors.c errors.h Makefile
 	$(CC) ${CFLAGS} -c $< -o $@
 
-options.o: options.c options.h errors.h Makefile
+options.o: options.c options.h errors.h FAT_fs.h Makefile
 	$(CC) ${CFLAGS} -c $< -o $@
 
 clusterchain.o: clusterchain.c clusterchain.h errors.h Makefile
@@ -42,8 +43,11 @@
 misc.o: misc.c misc.h options.h Makefile
 	$(CC) ${CFLAGS} -c $< -o $@
 
+natstrcmp.o: natstrcmp.c natstrcmp.h Makefile
+	$(CC) ${CFLAGS} -c $< -o $@
+
 install:
-	install -m 0755 -p -D fatsort $(DESTDIR)$(SBINDIR)
+	install -m 0755 -p -D fatsort $(DESTDIR)$(SBINDIR)/fatsort
 
 clean:
 	rm -f *.o fatsort

## fatsort 0.9.14

=== Makefile ===
MANDIR=/usr/local/share/man/man1

all:
	$(MAKE) -C src/
clean:
	$(MAKE) -C src/ clean
install:
	install -m 0755 -p -D man/fatsort.1 $(DESTDIR)$(MANDIR)/fatsort.1
	$(MAKE) -C src/ install

=== src/Makefile ===
--- 
+++ 
@@ -2,7 +2,23 @@
 LD=gcc
 CFLAGS += -g -Wall
 override CFLAGS+= -D_LARGEFILE_SOURCE -D_FILE_OFFSET_BITS=64
-LDFLAGS = -s 
+
+ifeq ($(OSTYPE), darwin)
+NEED_ICONV_LIB = 1
+endif
+
+ifeq ($(OSTYPE),FreeBSD)
+override CFLAGS += -I/usr/local/include
+LDFLAGS += -L/usr/local/lib
+NEED_ICONV_LIB = 1
+endif
+
+ifdef NEED_ICONV_LIB
+LDFLAGS += -s -liconv
+else
+LDFLAGS += -s
+endif
+
 SBINDIR=/usr/local/sbin
 
 all: fatsort

=== debian/changelog ===
fatsort (0.9.14-1) unstable; urgency=low

  * New upstream release.

 -- Sebastian Dröge <slomo@debian.org>  Mon, 24 May 2010 10:43:57 +0200

fatsort (0.9.13.1+-1) unstable; urgency=low

  * Reupload of 0.9.13.1 with a new tarball because of ftp-master
    hardware problem which affected the 0.9.13.1 tarball.

 -- Sebastian Dröge <slomo@debian.org>  Thu, 25 Mar 2010 22:42:55 +0100

fatsort (0.9.13.1-1) unstable; urgency=low

  * New upstream release.
  * debian/control,
    debian/compat,
    debian/source/format:
    + Update to Standards-Version 3.8.4.
    + Update to debhelper compat level 7.
    + Update to source format 3.0 (quilt).

 -- Sebastian Dröge <slomo@debian.org>  Mon, 22 Mar 2010 14:41:55 +0100

fatsort (0.9.12-1) unstable; urgency=low

  * New upstream release:
    + Fixes segfaults in writeClusterChain (Closes: #543986).
  * debian/rules,
    debian/fatsort.1*,
    debian/control:
    + Use upstream manpage instead of our own outdated (Closes: #548442).

 -- Sebastian Dröge <slomo@debian.org>  Fri, 02 Oct 2009 09:17:58 +0200

fatsort (0.9.10-1) unstable; urgency=low

  * New upstream release (Closes: #542109).
  * debian/rules:
    + Adding large file support to the CFLAGS is not necessary anymore.
  * debian/compat,
    debian/rules:
    + Update debhelper compat version.
    + Update Standards-Version.

 -- Sebastian Dröge <slomo@debian.org>  Tue, 18 Aug 2009 08:23:33 +0200

fatsort (0.9.8.3-1) unstable; urgency=low

  * New upstream release:
    + Fixes mount detection (Closes: #490019).

 -- Sebastian Dröge <slomo@debian.org>  Thu, 09 Oct 2008 07:34:56 +0200

fatsort (0.9.8.2-1) unstable; urgency=low

  * New upstream release:
    + debian/rules:
      - Adjust to build system changes.
  * debian/control:
    + Update Standards-Version to 3.8.0, no additional changes needed.
    + Move homepage to the Homepage field.
  * debian/watch:
    + Remove watch file until a way that works with berlios
      is found (Closes: #449870).

 -- Sebastian Dröge <slomo@debian.org>  Mon, 07 Jul 2008 11:58:05 +0200

fatsort (0.9.7.1-1) unstable; urgency=low

  * New upstream release, adds support for files > 4GB

 -- Sebastian Dröge <slomo@debian.org>  Sun, 22 Jul 2007 23:55:34 +0200

fatsort (0.9.7-2) unstable; urgency=low

  * Upload to unstable

 -- Sebastian Dröge <slomo@debian.org>  Mon, 16 Apr 2007 02:24:39 +0200

fatsort (0.9.7-1) experimental; urgency=low

  * New upstream release:
    + Check if the device is mounted (Closes: #393652)
  * debian/control:
    + Update to use my debian.org mail address

 -- Sebastian Dröge <slomo@debian.org>  Thu,  1 Feb 2007 15:26:25 +0100

fatsort (0.9.6.1-1) unstable; urgency=low

  * New upstream release
  * debian/control:
    + Bumped Standards-Version to 3.7.2
    + Bumped debhelper compat level to 5
  * debian/fatsort.1.xml:
    + Update my email address

 -- Sebastian Dröge <slomo@ubuntu.com>  Mon, 10 Jul 2006 02:33:25 +0200

fatsort (0.9.4-1) unstable; urgency=low

  * Initial Revision (Closes: #333084)

 -- Sebastian Dröge <slomo@ubuntu.com>  Fri,  9 Sep 2005 15:43:36 +0200

## fatsort 0.9.15.245

=== Makefile ===
MANDIR=/usr/local/share/man/man1

INSTALL_FLAGS=-m 0755 -p -D

#detect Mac OS X
UNAME=$(shell uname -s)
ifeq ($(UNAME),Darwin)
INSTALL_FLAGS=-m 0755 -p
endif

all:
	$(MAKE) -C src/
clean:
	$(MAKE) -C src/ clean
install:
	install $(INSTALL_FLAGS) man/fatsort.1 $(DESTDIR)$(MANDIR)/fatsort.1
	$(MAKE) -C src/ install

=== src/Makefile ===
--- 
+++ 
@@ -1,10 +1,24 @@
 CC=gcc
 LD=gcc
-CFLAGS += -g -Wall
+
+ifdef DEBUG
+CFLAGS += -g -DDEBUG=$(DEBUG)
+DEBUG_OBJ=mallocv.o
+else
+LDFLAGS += -s
+endif
+
+CFLAGS += -Wall
 override CFLAGS+= -D_LARGEFILE_SOURCE -D_FILE_OFFSET_BITS=64
 
-ifeq ($(OSTYPE), darwin)
+INSTALL_FLAGS=-m 0755 -p -D
+
+# Detect Mac OS X ($OSTYPE = darwin9.0 for Mac OS X 10.5 and darwin10.0 for Mac OS X 10.6)
+UNAME=$(shell uname -s)
+ifeq ($(UNAME),Darwin)
 NEED_ICONV_LIB = 1
+# OS X's install does not support the '-D' flag.
+INSTALL_FLAGS=-m 0755 -p
 endif
 
 ifeq ($(OSTYPE),FreeBSD)
@@ -14,17 +28,22 @@
 endif
 
 ifdef NEED_ICONV_LIB
-LDFLAGS += -s -liconv
-else
-LDFLAGS += -s
+LDFLAGS += -liconv
 endif
 
+# Mac OS X does not have a "/usr/local/sbin"
+ifeq ($(UNAME),Darwin)
+SBINDIR=/usr/local/bin
+else
 SBINDIR=/usr/local/sbin
+endif
+
+OBJ=fatsort.o FAT_fs.o fileio.o endianness.o signal.o entrylist.o errors.o options.o clusterchain.o sort.o misc.o natstrcmp.o stringlist.o
 
 all: fatsort
 
-fatsort: fatsort.o FAT_fs.o fileio.o endianness.o signal.o entrylist.o errors.o options.o clusterchain.o sort.o misc.o natstrcmp.o Makefile
-	${LD} ${LDFLAGS} *.o -o fatsort
+fatsort: $(OBJ) $(DEBUG_OBJ) Makefile
+	${LD} ${LDFLAGS} $(OBJ) $(DEBUG_OBJ) -o $@
 
 fatsort.o: fatsort.c endianness.h signal.h FAT_fs.h options.h errors.h sort.h misc.h Makefile
 	$(CC) ${CFLAGS} -c $< -o $@
@@ -62,9 +81,12 @@
 natstrcmp.o: natstrcmp.c natstrcmp.h Makefile
 	$(CC) ${CFLAGS} -c $< -o $@
 
+stringlist.o: stringlist.c stringlist.h platform.h errors.h Makefile
+	$(CC) ${CFLAGS} -c $< -o $@
+
 install:
-	install -m 0755 -p -D fatsort $(DESTDIR)$(SBINDIR)/fatsort
-
+	install $(INSTALL_FLAGS) fatsort $(DESTDIR)$(SBINDIR)/fatsort
+	
 clean:
 	rm -f *.o fatsort

=== debian/changelog ===
fatsort (0.9.15.245-1) unstable; urgency=low

  * New upstream release

 -- Sebastian Dröge <slomo@debian.org>  Tue, 30 Aug 2011 16:40:55 +0200

=== debian/control ===
Source: fatsort
Section: utils
Priority: extra
Maintainer: Sebastian Dröge <slomo@debian.org>
Build-Depends: cdbs (>= 0.4.20),
               debhelper (>= 7)
Standards-Version: 3.8.4
Homepage: http://fatsort.berlios.de/

Package: fatsort
Architecture: any
Section: utils
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: utility for sorting FAT directory structures
 FATSort is a utility that sorts FAT16 and FAT32 partitions. It even
 can handle long file name entries. It reads the boot sector and sorts
 the directory structure recursively.
 This is for example useful for sorting the files on your MP3 player when
 it doesn't implement a sorting function itself.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/makefile.mk

DEB_MAKE_INSTALL_TARGET :=
DEB_MAKE_CLEAN_TARGET := clean

DEB_INSTALL_MANPAGES_fatsort := man/fatsort.1

install/fatsort::
	dh_install src/fatsort /usr/bin

## fatsort 1.3.365

=== Makefile ===
--- 
+++ 
@@ -8,10 +8,23 @@
 INSTALL_FLAGS=-m 0755 -p
 endif
 
-all:
+all: man
+
+src:
 	$(MAKE) -C src/
+
+man: src
+	$(MAKE) -C man/ 
+
 clean:
 	$(MAKE) -C src/ clean
+	${MAKE} -C tests/ clean
 install:
 	install $(INSTALL_FLAGS) man/fatsort.1 $(DESTDIR)$(MANDIR)/fatsort.1
 	$(MAKE) -C src/ install
+tests: all
+	$(MAKE) -C tests/
+
+
+.PHONY: src man tests clean
+

=== man/Makefile ===
HELP2MAN=help2man

all: fatsort.1

fatsort.1: ../src/fatsort
	${HELP2MAN} --name "FAT sorting tool" ../src/fatsort -o fatsort.1 -N

=== src/Makefile ===
CC=gcc
LD=gcc

ifdef DEBUG
CFLAGS += -g -DDEBUG=$(DEBUG) -fstack-protector-all
DEBUG_OBJ=mallocv.o
else
LDFLAGS += -s
endif

CFLAGS += -Wall -Wextra
override CFLAGS+= -D_LARGEFILE_SOURCE -D_FILE_OFFSET_BITS=64

INSTALL_FLAGS=-m 0755 -p -D

# Detect Mac OS X ($OSTYPE = darwin9.0 for Mac OS X 10.5 and darwin10.0 for Mac OS X 10.6)
UNAME=$(shell uname -s)
ifeq ($(UNAME),Darwin)
NEED_ICONV_LIB = 1
# OS X's install does not support the '-D' flag.
INSTALL_FLAGS=-m 0755 -p
endif

ifeq ($(OSTYPE),FreeBSD)
override CFLAGS += -I/usr/local/include
LDFLAGS += -L/usr/local/lib
NEED_ICONV_LIB = 1
endif

ifdef NEED_ICONV_LIB
LDFLAGS += -liconv
endif

# Mac OS X does not have a "/usr/local/sbin"
ifeq ($(UNAME),Darwin)
SBINDIR=/usr/local/bin
else
SBINDIR=/usr/local/sbin
endif

OBJ=fatsort.o FAT_fs.o fileio.o endianness.o signal.o entrylist.o errors.o options.o clusterchain.o sort.o misc.o natstrcmp.o stringlist.o

all: fatsort

fatsort: $(OBJ) $(DEBUG_OBJ) Makefile
	${LD} ${LDFLAGS} $(OBJ) $(DEBUG_OBJ) -o $@

fatsort.o: fatsort.c endianness.h signal.h FAT_fs.h platform.h options.h \
 stringlist.h errors.h sort.h clusterchain.h misc.h mallocv.h Makefile
	$(CC) ${CFLAGS} -c $< -o $@

FAT_fs.o: FAT_fs.c FAT_fs.h platform.h errors.h endianness.h fileio.h \
 mallocv.h Makefile
	$(CC) ${CFLAGS} -c $< -o $@

fileio.o: fileio.c fileio.h platform.h Makefile
	$(CC) ${CFLAGS} -c $< -o $@

endianness.o: endianness.c endianness.h mallocv.h Makefile
	$(CC) ${CFLAGS} -c $< -o $@

signal.o: signal.c signal.h mallocv.h Makefile
	$(CC) ${CFLAGS} -c $< -o $@

entrylist.o: entrylist.c entrylist.h FAT_fs.h platform.h options.h \
 stringlist.h errors.h natstrcmp.h mallocv.h Makefile
	$(CC) ${CFLAGS} -c $< -o $@

errors.o: errors.c errors.h mallocv.h Makefile
	$(CC) ${CFLAGS} -c $< -o $@

options.o: options.c options.h platform.h FAT_fs.h stringlist.h errors.h \
 mallocv.h Makefile
	$(CC) ${CFLAGS} -c $< -o $@

clusterchain.o: clusterchain.c clusterchain.h platform.h errors.h \
 mallocv.h Makefile
	$(CC) ${CFLAGS} -c $< -o $@

sort.o: sort.c sort.h FAT_fs.h platform.h clusterchain.h entrylist.h \
 errors.h options.h stringlist.h endianness.h signal.h misc.h fileio.h \
 mallocv.h Makefile
	$(CC) ${CFLAGS} -c $< -o $@

misc.o: misc.c misc.h options.h platform.h FAT_fs.h stringlist.h \
 mallocv.h Makefile
	$(CC) ${CFLAGS} -c $< -o $@

natstrcmp.o: natstrcmp.c natstrcmp.h mallocv.h Makefile
	$(CC) ${CFLAGS} -c $< -o $@

stringlist.o: stringlist.c stringlist.h platform.h FAT_fs.h errors.h \
 mallocv.h Makefile
	$(CC) ${CFLAGS} -c $< -o $@

mallocv.o: mallocv.c mallocv.h errors.h
	$(CC) ${CFLAGS} -c $< -o $@

install:
	install $(INSTALL_FLAGS) fatsort $(DESTDIR)$(SBINDIR)/fatsort
	
clean:
	rm -f *.o fatsort

.PHONY: all clean

=== tests/Makefile ===
SHELL=/bin/bash

.PHONY: clean

LOGFILE=test_results.log

all:
	@which bbe &>/dev/null || (echo "You need bbe to run the tests!"; false)
	@which mkfs.vfat &>/dev/null || (echo "You need mkfs.vfat to run the tests!"; false)
	@which fsck.vfat &>/dev/null || (echo "You need fsck.vfat to run the tests!"; false)
	@if [ -f ${LOGFILE} ]; then rm -f ${LOGFILE}; fi
	@failed=0; \
	for i in `ls -d tc_*`; do \
		if [ ! -f $$i/passed ]; then \
			printf "%.70s" "Test case $$i...                                                                 "; \
			printf "[ \e[1;33mWAIT \e[0m]"; \
			echo "=============================================" >> ${LOGFILE}; \
			echo "Test case $$i" >> ${LOGFILE}; \
			echo "=============================================" >> ${LOGFILE}; \
			make -C $$i &>> ${LOGFILE}; \
			ret=$$?; \
			printf "\r%.70s" "Test case $$i...                                                                 "; \
			if [ $$ret -eq 0 ]; then \
				printf "[ \e[1;32mPASS \e[0m]\n"; \
			else \
				printf "[ \e[1;31mFAIL \e[0m]\n"; \
				(( failed+=1 )); \
			fi; \
		fi; \
	done; \
	if [ $$failed -eq 0 ]; then \
		echo "All tests passed."; \
	else \
		echo $$failed "test(s) failed!"; \
	fi

clean:
	rm -f ${LOGFILE}
	for i in `ls -d tc_*`; do $(MAKE) -C $$i clean || [ 1 ]; done

=== tests/tc_check_consistent_version/Makefile ===
include ../testconfig.mk

all: 
	manver=\
	`head -2 ../../man/fatsort.1 | tail -1 | sed -e "s/^.*\"fatsort \([0-9.]\+\)\".*$$/\1/"`; \
	progver=`../../src/fatsort --version | head -1 | sed -e "s/^fatsort \([0-9.]\+\).*$$/\1/"`; \
	changesver=`head -1 ../../CHANGES | sed -e "s/^.*v\([0-9.]\+\)$$/\1/"`; \
	echo "#$$manver#$$progver#$$changesver#"; \
	[ "$$manver" = "$$progver" ]; \
	[ "$$changesver" = "$$progver" ]


clean:

.PHONY: clean

=== tests/tc_check_for_open_TODOs/Makefile ===
include ../testconfig.mk

all: 
	! grep "TODO" ../../src/*.[hc]

clean:

.PHONY: clean

=== tests/tc_neg_bad_checksum_in_lne/Makefile ===
include ../testconfig.mk

FS_FATType=32
# 100 MiBytes
FS_SIZE=100
FS_FATs=2
FS_VOL_NAME=test
FS_ROOT_ENTRIES=512
FS_RSVD_SEC=32
FS_SEC_PER_CLUS=1
FS_SEC_SIZE=512

DIRECTORIES=directories.txt
FILES=files.txt

TESTLOG=test.log

STDOUT=stdout.log
STDOUT_EXP=stdout_expected.txt
STDERR=stderr.log
STDERR_EXP=stderr_expected.txt

# no fsck in negative tests
all: execute
	if [ ${DEL_FS_ON_PASS} -eq 1 ]; then rm -f ${FS_IMG}; fi

clean:
	rm -fr *.log *.tmp ${FS_IMG} ${TMPFILE} ${TMPDIR}
	if [ -d ${MOUNT_POINT} ]; then \
	until sudo umount ${MOUNT_POINT}; do sleep 1; done; \
	rmdir ${MOUNT_POINT}; \
	fi

# create file system
mkfs:
	# ++++++++++ Creating file ${FATType} system ++++++++++
	rm -f ${FS_IMG}
	truncate -s ${FS_SIZE}MB ${FS_IMG}
	mkfs.vfat -F ${FS_FATType} -f ${FS_FATs} -n ${FS_VOL_NAME} -r ${FS_ROOT_ENTRIES} -R ${FS_RSVD_SEC} -s ${FS_SEC_PER_CLUS} -S ${FS_SEC_SIZE} ${FS_IMG}

# populate fs
populatefs: mkfs
	# ++++++++++ Populating file system with directories and files ++++++++++
	mkdir -p ${MOUNT_POINT}
	sudo mount -o loop,codepage=850,iocharset=iso8859-1,utf8,uid=${MOUNT_UID},gid=${MOUNT_GID} ${FS_IMG} ${MOUNT_POINT}
	cat ${DIRECTORIES} | while read dir; do mkdir -p "${MOUNT_POINT}/$$dir"; done
	cat ${FILES} | while read file; do touch "${MOUNT_POINT}/$$file"; done
	rm -f "${MOUNT_POINT}/a" #remove some files
	rm -f "${MOUNT_POINT}/n"
	rm -f "${MOUNT_POINT}/z"
	until sudo umount ${MOUNT_POINT}; do sleep 1; done
	rmdir ${MOUNT_POINT}

# alter file system as necessary for the test
alterfs: populatefs
	# ++++++++++ Altering file system ++++++++++
	${BBE} -b x17bc8d:1 -e "r 0 \x42"  ${FS_IMG} > ${TMPFILE} # alter checksum in lne
	cp -f ${TMPFILE} ${FS_IMG}
	rm -fr ${TMPFILE}

execute: alterfs
	# ++++++++++ Executing tests ++++++++++
	${FATSORT} ${FS_IMG} > ${STDOUT} 2> ${STDERR}; [ $$? -ne 0 ]
	diff ${STDOUT} ${STDOUT_EXP}
	diff ${STDERR} ${STDERR_EXP}

# check result
fsck: execute
	# ++++++++++ Checking file system ++++++++++
	fsck.vfat -n ${FS_IMG}

.PHONY: fsck execute populatefs mkfs clean

=== tests/tc_neg_bad_count_of_root_dir_entries_fat12/Makefile ===
include ../testconfig.mk

FS_FATType=12
# 100 MiBytes
FS_SIZE=10
FS_FATs=2
FS_VOL_NAME=test
FS_ROOT_ENTRIES=512
FS_RSVD_SEC=1
FS_SEC_PER_CLUS=16
FS_SEC_SIZE=512

DIRECTORIES=directories.txt
FILES=files.txt

TESTLOG=test.log

STDOUT=stdout.log
STDOUT_EXP=stdout_expected.txt
STDERR=stderr.log
STDERR_EXP=stderr_expected.txt

# no fsck in negative tests
all: execute
	if [ ${DEL_FS_ON_PASS} -eq 1 ]; then rm -f ${FS_IMG}; fi

clean:
	rm -fr *.log *.tmp ${FS_IMG} ${TMPFILE} ${TMPDIR}
	if [ -d ${MOUNT_POINT} ]; then \
	until sudo umount ${MOUNT_POINT}; do sleep 1; done; \
	rmdir ${MOUNT_POINT}; \
	fi

# create file system
mkfs:
	# ++++++++++ Creating file ${FATType} system ++++++++++
	rm -f ${FS_IMG}
	truncate -s ${FS_SIZE}MB ${FS_IMG}
	mkfs.vfat -F ${FS_FATType} -f ${FS_FATs} -n ${FS_VOL_NAME} -r ${FS_ROOT_ENTRIES} -R ${FS_RSVD_SEC} -s ${FS_SEC_PER_CLUS} -S ${FS_SEC_SIZE} ${FS_IMG}

# populate fs
populatefs: mkfs
	# ++++++++++ Populating file system with directories and files ++++++++++
	mkdir -p ${MOUNT_POINT}
	sudo mount -o loop,codepage=850,iocharset=iso8859-1,utf8,uid=${MOUNT_UID},gid=${MOUNT_GID} ${FS_IMG} ${MOUNT_POINT}
	cat ${DIRECTORIES} | while read dir; do mkdir -p "${MOUNT_POINT}/$$dir"; done
	cat ${FILES} | while read file; do touch "${MOUNT_POINT}/$$file"; done
	until sudo umount ${MOUNT_POINT}; do sleep 1; done
	rmdir ${MOUNT_POINT}

# alter file system as necessary for the test
alterfs: populatefs
	# ++++++++++ Altering file system ++++++++++
	# set root dir entries to 0 (bad for FAT16/FAT12)
	${BBE} -b x11:2 -e "r 0 \x00\x00" ${FS_IMG} > ${TMPFILE}
	cp ${TMPFILE} ${FS_IMG}
	rm -fr ${TMPFILE}

execute: alterfs
	# ++++++++++ Executing tests ++++++++++
	${FATSORT} ${FS_IMG} > ${STDOUT} 2> ${STDERR}; [ $$? -ne 0 ]
	diff ${STDOUT} ${STDOUT_EXP}
	diff ${STDERR} ${STDERR_EXP}

# check result
fsck: execute
	# ++++++++++ Checking file system ++++++++++
	fsck.vfat -n ${FS_IMG}

.PHONY: fsck execute populatefs mkfs clean

=== tests/tc_neg_bad_count_of_root_dir_entries_fat16/Makefile ===
include ../testconfig.mk

FS_FATType=16
# 100 MiBytes
FS_SIZE=10
FS_FATs=2
FS_VOL_NAME=test
FS_ROOT_ENTRIES=512
FS_RSVD_SEC=1
FS_SEC_PER_CLUS=1
FS_SEC_SIZE=512

DIRECTORIES=directories.txt
FILES=files.txt

TESTLOG=test.log

STDOUT=stdout.log
STDOUT_EXP=stdout_expected.txt
STDERR=stderr.log
STDERR_EXP=stderr_expected.txt

# no fsck in negative tests
all: execute
	if [ ${DEL_FS_ON_PASS} -eq 1 ]; then rm -f ${FS_IMG}; fi

clean:
	rm -fr *.log *.tmp ${FS_IMG} ${TMPFILE} ${TMPDIR}
	if [ -d ${MOUNT_POINT} ]; then \
	until sudo umount ${MOUNT_POINT}; do sleep 1; done; \
	rmdir ${MOUNT_POINT}; \
	fi

# create file system
mkfs:
	# ++++++++++ Creating file ${FATType} system ++++++++++
	rm -f ${FS_IMG}
	truncate -s ${FS_SIZE}MB ${FS_IMG}
	mkfs.vfat -F ${FS_FATType} -f ${FS_FATs} -n ${FS_VOL_NAME} -r ${FS_ROOT_ENTRIES} -R ${FS_RSVD_SEC} -s ${FS_SEC_PER_CLUS} -S ${FS_SEC_SIZE} ${FS_IMG}

# populate fs
populatefs: mkfs
	# ++++++++++ Populating file system with directories and files ++++++++++
	mkdir -p ${MOUNT_POINT}
	sudo mount -o loop,codepage=850,iocharset=iso8859-1,utf8,uid=${MOUNT_UID},gid=${MOUNT_GID} ${FS_IMG} ${MOUNT_POINT}
	cat ${DIRECTORIES} | while read dir; do mkdir -p "${MOUNT_POINT}/$$dir"; done
	cat ${FILES} | while read file; do touch "${MOUNT_POINT}/$$file"; done
	until sudo umount ${MOUNT_POINT}; do sleep 1; done
	rmdir ${MOUNT_POINT}

# alter file system as necessary for the test
alterfs: populatefs
	# ++++++++++ Altering file system ++++++++++
	# set root dir entries to 0 (bad for FAT16/FAT12)
	${BBE} -b x11:2 -e "r 0 \x00\x00" ${FS_IMG} > ${TMPFILE}
	cp ${TMPFILE} ${FS_IMG}
	rm -fr ${TMPFILE}

execute: alterfs
	# ++++++++++ Executing tests ++++++++++
	${FATSORT} ${FS_IMG} > ${STDOUT} 2> ${STDERR}; [ $$? -ne 0 ]
	diff ${STDOUT} ${STDOUT_EXP}
	diff ${STDERR} ${STDERR_EXP}

# check result
fsck: execute
	# ++++++++++ Checking file system ++++++++++
	fsck.vfat -n ${FS_IMG}

.PHONY: fsck execute populatefs mkfs clean

=== tests/tc_neg_bad_count_of_root_dir_entries_fat32/Makefile ===
include ../testconfig.mk

FS_FATType=32
# 100 MiBytes
FS_SIZE=100
FS_FATs=2
FS_VOL_NAME=test
FS_ROOT_ENTRIES=512
FS_RSVD_SEC=32
FS_SEC_PER_CLUS=1
FS_SEC_SIZE=512

DIRECTORIES=directories.txt
FILES=files.txt

TESTLOG=test.log

STDOUT=stdout.log
STDOUT_EXP=stdout_expected.txt
STDERR=stderr.log
STDERR_EXP=stderr_expected.txt

# no fsck in negative tests
all: execute
	if [ ${DEL_FS_ON_PASS} -eq 1 ]; then rm -f ${FS_IMG}; fi

clean:
	rm -fr *.log *.tmp ${FS_IMG} ${TMPFILE} ${TMPDIR}
	if [ -d ${MOUNT_POINT} ]; then \
	until sudo umount ${MOUNT_POINT}; do sleep 1; done; \
	rmdir ${MOUNT_POINT}; \
	fi

# create file system
mkfs:
	# ++++++++++ Creating file ${FATType} system ++++++++++
	rm -f ${FS_IMG}
	truncate -s ${FS_SIZE}MB ${FS_IMG}
	mkfs.vfat -F ${FS_FATType} -f ${FS_FATs} -n ${FS_VOL_NAME} -r ${FS_ROOT_ENTRIES} -R ${FS_RSVD_SEC} -s ${FS_SEC_PER_CLUS} -S ${FS_SEC_SIZE} ${FS_IMG}

# populate fs
populatefs: mkfs
	# ++++++++++ Populating file system with directories and files ++++++++++
	mkdir -p ${MOUNT_POINT}
	sudo mount -o loop,codepage=850,iocharset=iso8859-1,utf8,uid=${MOUNT_UID},gid=${MOUNT_GID} ${FS_IMG} ${MOUNT_POINT}
	cat ${DIRECTORIES} | while read dir; do mkdir -p "${MOUNT_POINT}/$$dir"; done
	cat ${FILES} | while read file; do touch "${MOUNT_POINT}/$$file"; done
	until sudo umount ${MOUNT_POINT}; do sleep 1; done
	rmdir ${MOUNT_POINT}

# alter file system as necessary for the test
alterfs: populatefs
	# ++++++++++ Altering file system ++++++++++
	# set root dir entries to 32 (bad for FAT32)
	${BBE} -b x11:2 -e "r 0 \x20\x00" ${FS_IMG} > ${TMPFILE}
	cp ${TMPFILE} ${FS_IMG}
	rm -fr ${TMPFILE}

execute: alterfs
	# ++++++++++ Executing tests ++++++++++
	${FATSORT} ${FS_IMG} > ${STDOUT} 2> ${STDERR}; [ $$? -ne 0 ]
	diff ${STDOUT} ${STDOUT_EXP}
	diff ${STDERR} ${STDERR_EXP}

# check result
fsck: execute
	# ++++++++++ Checking file system ++++++++++
	fsck.vfat -n ${FS_IMG}

.PHONY: fsck execute populatefs mkfs clean

=== tests/tc_neg_bad_dir_entry_checksum/Makefile ===
include ../testconfig.mk

FS_FATType=32
# 100 MiBytes
FS_SIZE=100
FS_FATs=2
FS_VOL_NAME=test
FS_ROOT_ENTRIES=512
FS_RSVD_SEC=32
FS_SEC_PER_CLUS=1
FS_SEC_SIZE=512

DIRECTORIES=directories.txt
FILES=files.txt

TESTLOG=test.log

STDOUT=stdout.log
STDOUT_EXP=stdout_expected.txt
STDERR=stderr.log
STDERR_EXP=stderr_expected.txt

# no fsck in negative tests
all: execute
	if [ ${DEL_FS_ON_PASS} -eq 1 ]; then rm -f ${FS_IMG}; fi

clean:
	rm -fr *.log *.tmp ${FS_IMG} ${TMPFILE} ${TMPDIR}
	if [ -d ${MOUNT_POINT} ]; then \
	until sudo umount ${MOUNT_POINT}; do sleep 1; done; \
	rmdir ${MOUNT_POINT}; \
	fi

# create file system
mkfs:
	# ++++++++++ Creating file ${FATType} system ++++++++++
	rm -f ${FS_IMG}
	truncate -s ${FS_SIZE}MB ${FS_IMG}
	mkfs.vfat -F ${FS_FATType} -f ${FS_FATs} -n ${FS_VOL_NAME} -r ${FS_ROOT_ENTRIES} -R ${FS_RSVD_SEC} -s ${FS_SEC_PER_CLUS} -S ${FS_SEC_SIZE} ${FS_IMG}

# populate fs
populatefs: mkfs
	# ++++++++++ Populating file system with directories and files ++++++++++
	mkdir -p ${MOUNT_POINT}
	sudo mount -o loop,codepage=850,iocharset=iso8859-1,utf8,uid=${MOUNT_UID},gid=${MOUNT_GID} ${FS_IMG} ${MOUNT_POINT}
	cat ${DIRECTORIES} | while read dir; do mkdir -p "${MOUNT_POINT}/$$dir"; done
	cat ${FILES} | while read file; do touch "${MOUNT_POINT}/$$file"; done
	rm -f "${MOUNT_POINT}/a" #remove some files
	rm -f "${MOUNT_POINT}/n"
	rm -f "${MOUNT_POINT}/z"
	until sudo umount ${MOUNT_POINT}; do sleep 1; done
	rmdir ${MOUNT_POINT}

# alter file system as necessary for the test
alterfs: populatefs
	# ++++++++++ Altering file system ++++++++++
	# alter sne to change checksum
	${BBE} -b x17cde1:1 -e "r 0 \x41" ${FS_IMG}  > ${TMPFILE}
	cp -f ${TMPFILE} ${FS_IMG}
	rm -fr ${TMPFILE}

execute: alterfs
	# ++++++++++ Executing tests ++++++++++
	${FATSORT} ${FS_IMG} > ${STDOUT} 2> ${STDERR}; [ $$? -ne 0 ]
	diff ${STDOUT} ${STDOUT_EXP}
	diff ${STDERR} ${STDERR_EXP}

# check result
fsck: execute
	# ++++++++++ Checking file system ++++++++++
	fsck.vfat -n ${FS_IMG}

.PHONY: fsck execute populatefs mkfs clean

=== tests/tc_neg_bad_fat_size_fat12/Makefile ===
include ../testconfig.mk

FS_FATType=12
# 100 MiBytes
FS_SIZE=10
FS_FATs=2
FS_VOL_NAME=test
FS_ROOT_ENTRIES=512
FS_RSVD_SEC=32
FS_SEC_PER_CLUS=16
FS_SEC_SIZE=512

DIRECTORIES=directories.txt
FILES=files.txt

TESTLOG=test.log

STDOUT=stdout.log
STDOUT_EXP=stdout_expected.txt
STDERR=stderr.log
STDERR_EXP=stderr_expected.txt

# no fsck in negative tests
all: execute
	if [ ${DEL_FS_ON_PASS} -eq 1 ]; then rm -f ${FS_IMG}; fi

clean:
	rm -fr *.log *.tmp ${FS_IMG} ${TMPFILE} ${TMPDIR}
	if [ -d ${MOUNT_POINT} ]; then \
	until sudo umount ${MOUNT_POINT}; do sleep 1; done; \
	rmdir ${MOUNT_POINT}; \
	fi

# create file system
mkfs:
	# ++++++++++ Creating file ${FATType} system ++++++++++
	rm -f ${FS_IMG}
	truncate -s ${FS_SIZE}MB ${FS_IMG}
	mkfs.vfat -F ${FS_FATType} -f ${FS_FATs} -n ${FS_VOL_NAME} -r ${FS_ROOT_ENTRIES} -R ${FS_RSVD_SEC} -s ${FS_SEC_PER_CLUS} -S ${FS_SEC_SIZE} ${FS_IMG}

# populate fs
populatefs: mkfs
	# ++++++++++ Populating file system with directories and files ++++++++++
	mkdir -p ${MOUNT_POINT}
	sudo mount -o loop,codepage=850,iocharset=iso8859-1,utf8,uid=${MOUNT_UID},gid=${MOUNT_GID} ${FS_IMG} ${MOUNT_POINT}
	cat ${DIRECTORIES} | while read dir; do mkdir -p "${MOUNT_POINT}/$$dir"; done
	cat ${FILES} | while read file; do touch "${MOUNT_POINT}/$$file"; done
	until sudo umount ${MOUNT_POINT}; do sleep 1; done
	rmdir ${MOUNT_POINT}

# alter file system as necessary for the test
alterfs: populatefs
	# ++++++++++ Altering file system ++++++++++
	# set 16-bit count of fat sectors to zero (bad for FAT1x)
	${BBE} -b x16:2 -e "r 0 \x00\x00" ${FS_IMG} > ${TMPFILE}
	# necessary to fake a large amout of clusters
	${BBE} -b x24:4 -e "r 0 \x00\xff\xff\xff" ${TMPFILE} > ${FS_IMG}
	rm -fr ${TMPFILE}

execute: alterfs
	# ++++++++++ Executing tests ++++++++++
	${FATSORT} ${FS_IMG} > ${STDOUT} 2> ${STDERR}; [ $$? -ne 0 ]
	diff ${STDOUT} ${STDOUT_EXP}
	diff ${STDERR} ${STDERR_EXP}

# check result
fsck: execute
	# ++++++++++ Checking file system ++++++++++
	fsck.vfat -n ${FS_IMG}

.PHONY: fsck execute populatefs mkfs clean

=== debian/changelog ===
fatsort (1.3.365-1build1) bionic; urgency=high

  * No change rebuild to pick up -fPIE compiler default

 -- Balint Reczey <rbalint@ubuntu.com>  Tue, 03 Apr 2018 12:22:22 +0000

fatsort (1.3.365-1) unstable; urgency=medium

  * New upstream release (Closes: #717397, #557142).
  * debian/control:
    + Update homepage URL (Closes: #716721).

 -- Sebastian Dröge <slomo@debian.org>  Sat, 19 Sep 2015 13:26:11 +0200

=== debian/control ===
--- 
+++ 
@@ -1,11 +1,13 @@
 Source: fatsort
 Section: utils
 Priority: extra
-Maintainer: Sebastian Dröge <slomo@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Sebastian Dröge <slomo@debian.org>
 Build-Depends: cdbs (>= 0.4.20),
-               debhelper (>= 7)
+               debhelper (>= 7),
+               help2man
 Standards-Version: 3.8.4
-Homepage: http://fatsort.berlios.de/
+Homepage: http://fatsort.sourceforge.net
 
 Package: fatsort
 Architecture: any

## fatsort 1.6.2.605

=== Makefile ===
--- 
+++ 
@@ -14,11 +14,17 @@
 	$(MAKE) -C src/
 
 man: src
-	$(MAKE) -C man/ 
+	$(MAKE) -C man/
 
 clean:
 	$(MAKE) -C src/ clean
+	$(MAKE) -C man/ clean
+
+mrproper:
 	${MAKE} -C tests/ clean
+	$(MAKE) -C src/ clean
+	$(MAKE) -C man/ clean
+
 install:
 	install $(INSTALL_FLAGS) man/fatsort.1 $(DESTDIR)$(MANDIR)/fatsort.1
 	$(MAKE) -C src/ install
@@ -27,4 +33,3 @@
 
 
 .PHONY: src man tests clean
-

=== tests/Makefile ===
SHELL=/bin/bash
DATE=/bin/date

.PHONY: clean

LOGFILE="results.log"

TESTSUITES=$(wildcard ts_*)

all: ts_amd64

check_prerequisites:
#	@which valgrind &>/dev/null || (echo "You need valgrind to run the tests!"; false)

$(TESTSUITES): check_prerequisites 
	@SECONDS=0; failed=0; tests=0; new=0; \
	echo "Tests of testsuite $@ started on $(shell $(DATE) '+%Y-%m-%d %H:%M:%S')" | tee ${LOGFILE}; \
	for i in `cat $@`; do \
		if [ ! -f $$i/passed ]; then \
			printf "%.70s" "Test case $$i...                                                                 "; \
			printf "[ \e[1;33mWAIT \e[0m]"; \
			${MAKE} -C $$i &>> /dev/null; \
			ret=$$?; \
			printf "\r%.70s" "Test case $$i...                                                                 "; \
			if [ $$ret -eq 0 ]; then \
				printf "[ \e[1;32mPASS \e[0m]\n"; \
				echo "Test case $$i passed." >> $(LOGFILE); \
			else \
				printf "[ \e[1;31mFAIL \e[0m]\n"; \
				echo "Test case $$i failed." >> $(LOGFILE); \
				(( failed+=1 )); \
			fi; \
			(( new+=1 )); \
		fi; \
		(( tests+=1 )); \
	done; \
	ELAPSED="$$((($$SECONDS / 60) % 60))' $$(($$SECONDS % 60))\""; \
	if [ $$failed -eq 0 ]; then \
	echo "All" $$tests "tests passed ("$$new "in this round) in $$ELAPSED." | tee -a ${LOGFILE}; \
	else \
	echo $$failed"/"$$tests "tests failed! ("$$new "in this round) in $$ELAPSED." | tee -a ${LOGFILE}; \
	fi

clean:
	rm -f *.log
	rm -f tc_*/*.log tc*/passed
	rm -f images/*.img
#	for i in `ls -d tc_*`; do $(MAKE) -C $$i clean || [ 1 ]; done


.PHONY: check_prerequisites clean

=== debian/changelog ===
fatsort (1.6.2.605-1) unstable; urgency=medium

  * New upstream release
  * New maintainer (Closes: #954799)
  * debian/watch,
    debian/gbp.conf:
    + Added.
  * format debian/copyright to machine-readable
  * set Rules-Requires-Root to no
  * bump debhelper compatibility version to 12
  * update copyright years

 -- Jordi Sayol <g.sayol@gmail.com>  Mon, 04 May 2020 15:10:50 +0000

=== debian/control ===
Source: fatsort
Section: utils
Priority: optional
Maintainer: Jordi Sayol <g.sayol@gmail.com>
Rules-Requires-Root: no
Build-Depends: debhelper-compat (= 12),
               help2man
Standards-Version: 4.5.0
Homepage: http://fatsort.sourceforge.net

Package: fatsort
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: utility for sorting FAT directory structures
 FATSort is a utility that sorts FAT16 and FAT32 partitions. It even
 can handle long file name entries. It reads the boot sector and sorts
 the directory structure recursively.
 This is for example useful for sorting the files on your MP3 player when
 it doesn't implement a sorting function itself.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_install:
	dh_auto_install -- SBINDIR=/usr/bin MANDIR=/usr/share/man/man1

## fatsort 1.6.3.622

=== docker_tests/Makefile ===
DOCKER=$(shell which docker)
TOUCH=$(shell which touch)
WGET=$(shell which wget)
TAR=$(shell which tar)

DOCKERTESTS=$(wildcard docker_tests_*)

all: $(DOCKERTESTS)

important: docker_tests_i386 docker_tests_amd64 docker_tests_ppc

$(DOCKERTESTS): Makefile
	make -C $@

delete_all: delete_images

delete_images: delete_containers
	${DOCKER} rmi $(shell ${DOCKER} images -q) || true

delete_containers:
	${DOCKER} rm $(shell ${DOCKER} ps -a -q) || true

clean:
	for i in $(DOCKERTESTS); \
		do make -C $$i clean; \
	done

.PHONY: clean important $(DOCKERTESTS)

=== docker_tests/docker_tests_i386/Makefile ===
DOCKER=$(shell which podman)
TOUCH=$(shell which touch)
WGET=$(shell which wget)
TAR=$(shell which tar)

all: build_image
	$(DOCKER) run --rm --privileged -v ${CURDIR}:/home/tester/artifacts --tmpfs /tmp:rw,noexec,nosuid,size=2G -it fatsort-test-i386

build_image: Dockerfile do_tests.sh
	$(DOCKER) build -t fatsort-test-i386  .
	$(TOUCH) build_image

clean:
	rm -f *.log
	rm -f build_image
	rm -f *.tar.gz

.PHONY: clean build

=== docker_tests/docker_tests_s390x/Makefile ===
DOCKER=$(shell which podman)
TOUCH=$(shell which touch)
WGET=$(shell which wget)
TAR=$(shell which tar)

all: build_image
	$(DOCKER) run --rm --privileged -v ${CURDIR}:/home/tester/artifacts --tmpfs /tmp:rw,noexec,nosuid,size=2G -v ${CURDIR}/qemu-s390x-static:/usr/bin/qemu-s390x-static -it fatsort-test-s390x

build_image: Dockerfile qemu-s390x-static do_tests.sh
	$(DOCKER) build -t fatsort-test-s390x -v ${CURDIR}/qemu-s390x-static:/usr/bin/qemu-s390x-static  .
	$(TOUCH) build_image

qemu-s390x-static:
	$(WGET) https://github.com/multiarch/qemu-user-static/releases/download/v4.1.0-1/qemu-s390x-static.tar.gz
	$(TAR) xvfz qemu-s390x-static.tar.gz

/proc/sys/fs/binfmt_misc/s390x:
	$(DOCKER) run --rm --privileged multiarch/qemu-user-static:register

clean:
	rm -f *.log
	rm -f build_image
	rm -f *.tar.gz
	rm -f qemu-*-static

.PHONY: clean

=== tests/tc_check_consistent_version/Makefile ===
include ../testconfig.mk

all: passed 

execute:
	manver=\
	`head -2 ../../man/fatsort.1 | tail -1 | sed -e "s/^.*\"fatsort \([0-9.]\+\)\".*$$/\1/"`; \
	progver=`../../src/fatsort --version | head -1 | sed -e "s/^fatsort \([0-9.]\+\).*$$/\1/"`; \
	changesver=`head -3 ../../CHANGES.md | tail -1 | sed -e "s/^.*v\([0-9.]\+\).*$$/\1/"`; \
	echo "#$$manver#$$progver#$$changesver#"; \
	[ "$$manver" = "$$progver" ]; \
	[ "$$changesver" = "$$progver" ]

passed: execute
	touch passed

clean:
	rm -f passed

.PHONY: clean execute

=== tests/tc_check_for_open_TODOs/Makefile ===
include ../testconfig.mk

all: passed

passed: 
	! grep "TODO" ../../src/*.[hc]
	touch passed

clean:
	rm -f passed

.PHONY: clean

=== tests/tc_neg_bad_count_of_root_dir_entries_fat16/Makefile ===
include ../testconfig.mk

TESTLOG=test.log

STDOUT=stdout.log
STDOUT_EXP=stdout_expected.txt
STDERR=stderr.log
STDERR_EXP=stderr_expected.txt
REF_FS_XZ=${IMAGEDIR}/fat16_bad_count_of_root_dir_entries.img.xz

XZ=xz

all: passed
	if [ ${DEL_FS_ON_PASS} -eq 1 ]; then rm -f ${FS_IMG}; fi

clean:
	rm -f passed
	rm -fr *.log *.tmp ${FS_IMG} ${TMPFILE} ${TMPDIR}

$(FS_IMG): $(REF_FS_XZ)
	# ++++++++++ Unpacking reference file systen ++++++++++
	mkdir -p $(TMPDIR)
	${XZ} -d -f --stdout ${REF_FS_XZ} >> ${FS_IMG}

execute: $(FS_IMG)
	# ++++++++++ Executing tests ++++++++++
	${FATSORT} ${FS_IMG} > ${STDOUT} 2> ${STDERR}; [ $$? -ne 0 ]
	diff ${STDOUT} ${STDOUT_EXP}
	diff ${STDERR} ${STDERR_EXP}

# check result
fsck: execute
	# ++++++++++ Checking file system ++++++++++
	fsck.vfat -n ${FS_IMG}

# test passed
passed: execute
	touch passed

.PHONY: passed fsck execute clean

=== tests/tc_neg_bad_count_of_root_dir_entries_fat32/Makefile ===
include ../testconfig.mk

TESTLOG=test.log

STDOUT=stdout.log
STDOUT_EXP=stdout_expected.txt
STDERR=stderr.log
STDERR_EXP=stderr_expected.txt
REF_FS_XZ=${IMAGEDIR}/fat32_bad_count_of_root_dir_entries.img.xz

XZ=xz

all: passed
	if [ ${DEL_FS_ON_PASS} -eq 1 ]; then rm -f ${FS_IMG}; fi

clean:
	rm -f passed
	rm -fr *.log *.tmp ${FS_IMG} ${TMPFILE} ${TMPDIR}

$(FS_IMG): $(REF_FS_XZ)
	# ++++++++++ Unpacking reference file systen ++++++++++
	mkdir -p $(TMPDIR)
	${XZ} -d -f --stdout ${REF_FS_XZ} >> ${FS_IMG}

execute: $(FS_IMG)
	# ++++++++++ Executing tests ++++++++++
	${FATSORT} ${FS_IMG} > ${STDOUT} 2> ${STDERR}; [ $$? -ne 0 ]
	diff ${STDOUT} ${STDOUT_EXP}
	diff ${STDERR} ${STDERR_EXP}

# check result
fsck: execute
	# ++++++++++ Checking file system ++++++++++
	fsck.vfat -n ${FS_IMG}

# test passed
passed: execute
	touch passed

.PHONY: passed fsck execute clean

=== tests/tc_neg_bad_sector_size/Makefile ===
include ../testconfig.mk

TESTLOG=test.log

STDOUT=stdout.log
STDOUT_EXP=stdout_expected.txt
STDERR=stderr.log
STDERR_EXP=stderr_expected.txt
REF_FS_XZ=${IMAGEDIR}/fat32_bad_sector_size.img.xz

XZ=xz

all: passed
	if [ ${DEL_FS_ON_PASS} -eq 1 ]; then rm -f ${FS_IMG}; fi

clean:
	rm -f passed
	rm -fr *.log *.tmp ${FS_IMG} ${TMPFILE} ${TMPDIR}

$(FS_IMG): $(REF_FS_XZ)
	# ++++++++++ Unpacking reference file systen ++++++++++
	mkdir -p $(TMPDIR)
	${XZ} -d -f --stdout ${REF_FS_XZ} >> ${FS_IMG}

execute: $(FS_IMG)
	# ++++++++++ Executing tests ++++++++++
	${FATSORT} ${FS_IMG} > ${STDOUT} 2> ${STDERR}; [ $$? -ne 0 ]
	diff ${STDOUT} ${STDOUT_EXP}
	diff ${STDERR} ${STDERR_EXP}

# check result
fsck: execute
	# ++++++++++ Checking file system ++++++++++
	fsck.vfat -n ${FS_IMG}

# test passed
passed: execute
	touch passed

.PHONY: passed fsck execute clean

=== tests/tc_neg_bad_vbr_checksum_exfat/Makefile ===
include ../testconfig.mk

TESTLOG=test.log

STDOUT=stdout.log
STDOUT_EXP=stdout_expected.txt
STDERR=stderr.log
STDERR_EXP=stderr_expected.txt
REF_FS_XZ=${IMAGEDIR}/exfat_bad_vbr_checksum.img.xz

XZ=xz

all: passed
	if [ ${DEL_FS_ON_PASS} -eq 1 ]; then rm -f ${FS_IMG}; fi

clean:
	rm -f passed
	rm -fr *.log *.tmp ${FS_IMG} ${TMPFILE} ${TMPDIR}

$(FS_IMG): $(REF_FS_XZ)
	# ++++++++++ Unpacking reference file systen ++++++++++
	mkdir -p $(TMPDIR)
	${XZ} -d -f --stdout ${REF_FS_XZ} >> ${FS_IMG}

execute: $(FS_IMG)
	# ++++++++++ Executing tests ++++++++++
	${FATSORT} ${FS_IMG} > ${STDOUT} 2> ${STDERR}; [ $$? -ne 0 ]
	diff ${STDOUT} ${STDOUT_EXP}
	diff ${STDERR} ${STDERR_EXP}

# check result
fsck: execute
	# ++++++++++ Checking file system ++++++++++
	fsck.vfat -n ${FS_IMG}

# test passed
passed: execute
	touch passed

.PHONY: passed fsck execute clean

=== tests/tc_neg_cluster_chain_loop/Makefile ===
include ../testconfig.mk

TESTLOG=test.log

STDOUT=stdout.log
STDOUT_EXP=stdout_expected.txt
STDERR=stderr.log
STDERR_EXP=stderr_expected.txt
REF_FS_XZ=${IMAGEDIR}/fat32_cluster_chain_loop.img.xz

XZ=xz

all: passed
	if [ ${DEL_FS_ON_PASS} -eq 1 ]; then rm -f ${FS_IMG}; fi

clean:
	rm -f passed
	rm -fr *.log *.tmp ${FS_IMG} ${TMPFILE} ${TMPDIR}

$(FS_IMG): $(REF_FS_XZ)
	# ++++++++++ Unpacking reference file systen ++++++++++
	mkdir -p $(TMPDIR)
	${XZ} -d -f --stdout ${REF_FS_XZ} >> ${FS_IMG}

execute: $(FS_IMG)
	# ++++++++++ Executing tests ++++++++++
	${FATSORT} ${FS_IMG} > ${STDOUT} 2> ${STDERR}; [ $$? -ne 0 ]
	diff ${STDOUT} ${STDOUT_EXP}
	diff ${STDERR} ${STDERR_EXP}

# check result
fsck: execute
	# ++++++++++ Checking file system ++++++++++
	fsck.vfat -n ${FS_IMG}

# test passed
passed: execute
	touch passed

.PHONY: passed fsck execute clean

=== tests/tc_neg_fats_dont_match/Makefile ===
include ../testconfig.mk

TESTLOG=test.log

STDOUT=stdout.log
STDOUT_EXP=stdout_expected.txt
STDERR=stderr.log
STDERR_EXP=stderr_expected.txt
REF_FS_XZ=${IMAGEDIR}/fat32_fats_dont_match.img.xz

XZ=xz

all: passed
	if [ ${DEL_FS_ON_PASS} -eq 1 ]; then rm -f ${FS_IMG}; fi

clean:
	rm -f passed
	rm -fr *.log *.tmp ${FS_IMG} ${TMPFILE} ${TMPDIR}

$(FS_IMG): $(REF_FS_XZ)
	# ++++++++++ Unpacking reference file systen ++++++++++
	mkdir -p $(TMPDIR)
	${XZ} -d -f --stdout ${REF_FS_XZ} >> ${FS_IMG}

execute: $(FS_IMG)
	# ++++++++++ Executing tests ++++++++++
	${FATSORT} ${FS_IMG} > ${STDOUT} 2> ${STDERR}; [ $$? -ne 0 ]
	diff ${STDOUT} ${STDOUT_EXP}
	diff ${STDERR} ${STDERR_EXP}

# check result
fsck: execute
	# ++++++++++ Checking file system ++++++++++
	fsck.vfat -n ${FS_IMG}

# test passed
passed: execute
	touch passed

.PHONY: passed fsck execute clean

=== tests/tc_neg_maximum_cluster_nr/Makefile ===
include ../testconfig.mk

TESTLOG=test.log

STDOUT=stdout.log
STDOUT_EXP=stdout_expected.txt
STDERR=stderr.log
STDERR_EXP=stderr_expected.txt
REF_FS_XZ=${IMAGEDIR}/fat32_max_cluster_nr.img.xz

XZ=xz

all: passed
	if [ ${DEL_FS_ON_PASS} -eq 1 ]; then rm -f ${FS_IMG}; fi

clean:
	rm -f passed
	rm -fr *.log *.tmp ${FS_IMG} ${TMPFILE} ${TMPDIR}

$(FS_IMG): $(REF_FS_XZ)
	# ++++++++++ Unpacking reference file systen ++++++++++
	mkdir -p $(TMPDIR)
	${XZ} -d -f --stdout ${REF_FS_XZ} >> ${FS_IMG}

execute: $(FS_IMG)
	# ++++++++++ Executing tests ++++++++++
	${FATSORT} ${FS_IMG} > ${STDOUT} 2> ${STDERR}; [ $$? -ne 0 ]
	diff ${STDOUT} ${STDOUT_EXP}
	diff ${STDERR} ${STDERR_EXP}

# check result
fsck: execute
	# ++++++++++ Checking file system ++++++++++
	fsck.vfat -n ${FS_IMG}

# test passed
passed: execute
	touch passed

.PHONY: passed fsck execute clean

=== debian/changelog ===
fatsort (1.6.3.622-0.1) unstable; urgency=medium

  * Non-maintainer upload.
  * New upstream release (Closes: #966896).
  * debian/rules: build man page before install.

 -- Alex Muntada <alexm@debian.org>  Sat, 29 Aug 2020 12:58:14 +0200

=== debian/control ===
--- 
+++ 
@@ -3,9 +3,11 @@
 Priority: optional
 Maintainer: Jordi Sayol <g.sayol@gmail.com>
 Rules-Requires-Root: no
-Build-Depends: debhelper-compat (= 12),
+Build-Depends: debhelper-compat (= 13),
                help2man
 Standards-Version: 4.5.0
+Vcs-Git: https://salsa.debian.org/debian/fatsort.git
+Vcs-Browser: https://salsa.debian.org/debian/fatsort
 Homepage: http://fatsort.sourceforge.net
 
 Package: fatsort
